package com.fr.plugin.login.config.simple.account;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "微信鉴权配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.fr.plugin.login.config.simple", text = "微信鉴权配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "appId", name = "appId", description = "appId", status = Status.SHOW)
    private Conf<String> appId = Holders.simple("");

    @Identifier(value = "agentId", name = "agentId", description = "agentId", status = Status.SHOW)
    private Conf<String> agentId = Holders.simple("");

    @Identifier(value = "secret", name = "secret", description = "secret", status = Status.SHOW)
    private Conf<String> secret = Holders.simple("");

    @Identifier(value = "index", name = "帆软首页地址", description = "帆软首页地址", status = Status.SHOW)
    private Conf<String> index = Holders.simple("http/localhost:8075/webroot/decision");

    public String getAppId() {
        return appId.get();
    }

    public void setAppId(String url) {
        this.appId.set(url);
    }

    public String getAgentId() {
        return agentId.get();
    }

    public void setAgentId(String url) {
        this.agentId.set(url);
    }

    public String getSecret() {
        return secret.get();
    }

    public void setSecret(String url) {
        this.secret.set(url);
    }

    public String getIndex() {
        return index.get();
    }

    public void setIndex(String url) {
        this.index.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
