package com.fr.plugin.login.handler;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONObject;
import com.fr.plugin.login.config.simple.account.PluginSimpleConfig;
import com.fr.plugin.login.utils.ResponseUtils;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@FunctionRecorder
public class GetConfig extends BaseHttpHandler {


    public GetConfig() {
    }

    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/getConfig";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        String servletPath = req.getServletPath();
        String contextPath = req.getContextPath();
        String path =contextPath+servletPath;

        PluginSimpleConfig psc = PluginSimpleConfig.getInstance();
        String index = psc.getIndex();

        JSONObject json = new JSONObject();
        json.put("path",path);
        json.put("index",index);

        ResponseUtils.response(res,json);
    }
}

