package com.fr.plugin.login.handler;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.plugin.login.interception.filter.IpInterceptionFilter;
import com.fr.plugin.login.utils.ResponseUtils;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

@FunctionRecorder
public class GetIp extends BaseHttpHandler {


    public GetIp() {
    }

    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/getIp";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        String ip = IpInterceptionFilter.getIp(req);
        String username = req.getParameter("username");

        int type = 1;

        boolean inWhite = IpInterceptionFilter.checkUserInAllowList(username);
        boolean canLogin = IpInterceptionFilter.checkUserCanLoginOnIp(username,ip);

        if(inWhite && !canLogin){
            type = 0;
        }

        ResponseUtils.successResponse(res,String.valueOf(type));
    }

}

