package com.fr.plugin.login.handler;

import com.fr.base.TemplateUtils;
import com.fr.decision.config.AppearanceConfig;
import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.general.http.HttpToolbox;
import com.fr.plugin.login.config.simple.account.PluginSimpleConfig;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.controller.decision.api.auth.LoginResource;
import com.fr.web.utils.WebUtils;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.Map;

@FunctionRecorder
public class ToQrcode extends BaseHttpHandler {


    public ToQrcode() {
    }

    @Override
    public RequestMethod getMethod() {
        return RequestMethod.GET;
    }

    @Override
    public String getPath() {
        return "/toQrcode";
    }

    @Override
    public boolean isPublic() {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception {
        String origin = req.getParameter("origin");
        String url = AppearanceConfig.getInstance().getLoginUrl();
        String username = req.getParameter("username");
        PluginSimpleConfig pluginSimpleConfig = PluginSimpleConfig.getInstance();
        String appId = pluginSimpleConfig.getAppId();
        String agentId = pluginSimpleConfig.getAgentId();
        String index = pluginSimpleConfig.getIndex();
        String servletPath = req.getServletPath();
        String contextPath = req.getContextPath();
        String path2 =contextPath+servletPath;

        if(origin != null ){
            url = HttpToolbox.appendQuery(url,"origin",origin);
        }

        Map<String, String> parameterMap = new HashMap<String, String>();
        String path = "/com/fr/plugin/login/html/qrcode.html";
        parameterMap.put("remoteServletURL", WebUtils.getOriginalURL(req));
        parameterMap.put("username", username);
        parameterMap.put("appId", appId);
        parameterMap.put("agentId", agentId);
        parameterMap.put("index", index);
        parameterMap.put("path", path2);

        String macPage = TemplateUtils.renderTemplate(path, parameterMap);
        WebUtils.printAsString(res, macPage);
    }




}

