package com.fr.plugin.login.interception;

import com.fr.decision.plugin.db.AbstractDecisionDBAccessProvider;
import com.fr.plugin.login.interception.dao.IpInterceptionDao;
import com.fr.plugin.login.interception.dao.UserReleaseDao;
import com.fr.plugin.login.interception.entity.IpInterceptionEntity;
import com.fr.plugin.login.interception.entity.UserReleaseEntity;
import com.fr.plugin.transform.ExecuteFunctionRecord;
import com.fr.plugin.transform.FunctionRecorder;
import com.fr.stable.db.accessor.DBAccessor;
import com.fr.stable.db.dao.BaseDAO;
import com.fr.stable.db.dao.DAOProvider;

@FunctionRecorder
public class IpInterceptionDBAccessProvider extends AbstractDecisionDBAccessProvider {
    @Override
    @ExecuteFunctionRecord
    public DAOProvider[] registerDAO() {
        return new DAOProvider[]{
                new DAOProvider() {
                    @Override
                    public Class getEntityClass() {
                        return IpInterceptionEntity.class;
                    }
                    @Override
                    public Class<? extends BaseDAO> getDAOClass() {
                        return IpInterceptionDao.class;
                    }
                },
                new DAOProvider() {
                    @Override
                    public Class getEntityClass() {
                        return UserReleaseEntity.class;
                    }
                    @Override
                    public Class<? extends BaseDAO> getDAOClass() {
                        return UserReleaseDao.class;
                    }
                }
        };
    }

    private static DBAccessor dbAccessor = null;

    public static DBAccessor getDbAccessor(){
        return dbAccessor;
    }

    @Override
    public void onDBAvailable(DBAccessor dbAccessor) {
        IpInterceptionDBAccessProvider.dbAccessor = dbAccessor;
    }
}
