var t = "default_fail",
    e = BI.inherit(BI.OB, {
        init: function () {
            this.failMap = {},
                this._initErrorHandler()
        },
        addHandler: function (e, t) {
            this.failMap[e] = t
        },
        getHandler: function (e) {
            return BI.isFunction(this.failMap[e]) ? this.failMap[e] : this.failMap[t]
        },
        _initErrorHandler: function () {
            this.failMap[DecCst.ErrorCode.USER_LOGGED] = function (e) {
                this.store.setPropsInfo({
                    token: e.errorMsg,
                    isChangePwd: !0,
                    from: DecCst.Login.AuthenticationModule.SINGLE
                }),
                    this.store.setNeedSlider(!1),
                    this.loginErrorRow.visible()
            },
                this.failMap[DecCst.ErrorCode.USER_LOGGED_CAN_NOT_CHANGE_PASSWORD] = function () {
                    this.store.setNeedSlider(!1),
                        this.loginNormalErrorRow.visible()
                },
                this.failMap[DecCst.ErrorCode.USERNAME_UNAVAILABLE] = function () {
                    this.usernameRow.showError(BI.i18nText("Dec-Error_Login_Username_Unable"))
                },
                this.failMap[DecCst.ErrorCode.USERNAME_NOT_EXIST_PASSWORD_ERROR] = function () {
                    this.passwordRow.showError(BI.i18nText("Dec-Error_Incorrect_Password_Username"))
                },
                this.failMap[90000] = function () {
                    this.passwordRow.showError("您的电脑未授权，请联系管理员。")
                },
                this.failMap[DecCst.ErrorCode.SMS_CAPTCHA_UNCHECK] = function (e) {
                    this.store.setPropsInfo({
                        token: e.errorMsg,
                        isChangePwd: !1,
                        from: DecCst.Login.AuthenticationModule.LOGIN
                    }),
                        this.store.setSelectedTab(DecCst.Login.Tabs.VERIFY_BING)
                },
                this.failMap[DecCst.ErrorCode.PASSWORD_NEED_SPLIDER] = function () {
                    this.store.setNeedSlider(!0),
                        this.sliderBar.resetAll()
                },
                this.failMap[DecCst.ErrorCode.PASSWORD_LOCKED] = function (e) {
                    this.store.setPropsInfo({
                        errorMsg: e.errorMsg
                    }),
                        this.store.setSelectedTab(DecCst.Login.Tabs.LOCKED)
                },
                this.failMap[DecCst.ErrorCode.PASSWORD_NEED_UPDATE] = function (e) {
                    this.store.setPropsInfo({
                        token: e.errorMsg,
                        isChangePwd: !0,
                        from: DecCst.Login.AuthenticationModule.PWD_UPDATE
                    }),
                        this.model.isNeedVerify ? this.store.setSelectedTab(DecCst.Login.Tabs.VERIFY_BING) : this.store.setSelectedTab(DecCst.Login.Tabs.PASSWORD_OLD)
                },
                this.failMap[DecCst.ErrorCode.PASSWORD_STRENGTH] = function (e) {
                    this.store.setPropsInfo({
                        token: e.errorMsg,
                        isChangePwd: !0,
                        from: DecCst.Login.AuthenticationModule.PWD_STRENGTH
                    }),
                        this.model.isNeedVerify ? this.store.setSelectedTab(DecCst.Login.Tabs.VERIFY_BING) : this.store.setSelectedTab(DecCst.Login.Tabs.PASSWORD_OLD)
                },
                this.failMap[DecCst.ErrorCode.CAPTCHA_TIMEOUT] = function () {
                    this.sliderError.setText(BI.i18nText("Dec-Basic_Captcha_Timeout")),
                        this.sliderBar.resetAll()
                },
                this.addHandler(t, function () {
                    this.passwordRow.showError(BI.i18nText("Dec-Login_Fail"))
                })
        }
    });
BI.service("dec.service.login.login", e)

var e = BI.inherit(BI.Widget, {
    props: {
        baseCls: "dec-login-login"
    },
    _store: function () {
        return BI.Models.getModel("dec.model.login.login")
    },
    watch: {
        supportForgetPwd: function (e) {
            this.forgetPasswordRow.setVisible(e)
        },
        needSlider: function (e) {
            this.sliderMasker.setVisible(e)
        }
    },
    render: function () {
        var t = this;
        this.options;
        return {
            type: "bi.absolute",
            items: [{
                el: {
                    type: "bi.vertical",
                    items: [{
                        type: "dec.login.login.item",
                        $testId: "dec-login-username",
                        iconCls: "login-username-font",
                        tgap: 50,
                        watermark: BI.i18nText("Dec-User_Name"),
                        ref: function (e) {
                            t.usernameRow = e
                        }
                    }, {
                        type: "dec.login.login.item",
                        $testId: "dec-login-password",
                        iconCls: "login-password-font",
                        watermark: BI.i18nText("Dec-Password"),
                        inputType: "password",
                        ref: function (e) {
                            t.passwordRow = e
                        }
                    }, {
                        type: "bi.left_right_vertical_adapt",
                        bgap: 30,
                        items: {
                            left: [{
                                type: "bi.multi_select_item",
                                $testId: "dec-login-remember",
                                textLgap: 5,
                                iconWrapperWidth: 16,
                                height: 16,
                                text: BI.i18nText("Dec-Login_Remember"),
                                logic: {
                                    dynamic: !0
                                },
                                ref: function (e) {
                                    t.rememberRow = e
                                }
                            }
                            ],
                            right: [{
                                type: "bi.button",
                                $testId: "dec-login-forget-password",
                                clear: !0,
                                height: 16,
                                invisible: !this.model.supportForgetPwd,
                                text: BI.i18nText("Dec-Basic_Forget_Password"),
                                ref: function (e) {
                                    t.forgetPasswordRow = e
                                },
                                handler: function () {
                                    t.store.setSelectedTab(DecCst.Login.Tabs.FORGET_PASSWORD)
                                }
                            }
                            ].concat(this._createItems())
                        }
                    }, {
                        type: "bi.horizontal_auto",
                        items: [{
                            type: "bi.button",
                            cls: "login-button",
                            text: BI.i18nText("Dec-Basic_Login"),
                            width: 190,
                            height: 40,
                            handler: function () {
                                t._start()
                            }
                        }
                        ]
                    }, {
                        el: {
                            type: "bi.vertical",
                            $testId: "dec-login-logged-chang-text",
                            cls: "login-error",
                            invisible: !0,
                            scrolly: !1,
                            items: [{
                                type: "bi.text",
                                tagName: "span",
                                whiteSpace: "normal",
                                text: BI.i18nText("Dec-Login_Other_Logged_Tip")
                            }, {
                                type: "bi.text",
                                $testId: "dec-login-logged-chang-password",
                                tagName: "span",
                                cls: "password-btn",
                                text: BI.i18nText("Dec-Login_Change_Password"),
                                handler: function () {
                                    t.model.isNeedVerify ? t.store.setSelectedTab(DecCst.Login.Tabs.VERIFY_BING) : t.store.setSelectedTab(DecCst.Login.Tabs.PASSWORD_OLD)
                                }
                            }
                            ],
                            ref: function (e) {
                                t.loginErrorRow = e
                            }
                        },
                        tgap: 20
                    }, {
                        el: {
                            type: "bi.text",
                            $testId: "dec-login-logged-text",
                            cls: "login-error",
                            invisible: !0,
                            whiteSpace: "normal",
                            text: BI.i18nText("Dec-Login_Normal_Other_Logged_Tip"),
                            ref: function (e) {
                                t.loginNormalErrorRow = e
                            }
                        },
                        tgap: 20
                    }
                    ]
                },
                top: 0,
                right: 40,
                bottom: 0,
                left: 40
            }, {
                el: {
                    type: "bi.center_adapt",
                    cls: "slider-masker",
                    invisible: !0,
                    items: [{
                        type: "dec.login.slider",
                        listeners: [{
                            eventName: "EVENT_SUCCESS",
                            action: function () {
                                t._start()
                            }
                        }, {
                            eventName: "EVENT_CLOSE",
                            action: function () {
                                t.store.resetSlider()
                            }
                        }
                        ],
                        ref: function (e) {
                            t.sliderBar = e
                        }
                    }
                    ],
                    ref: function (e) {
                        t.sliderMasker = e
                    }
                },
                top: 0,
                right: 40,
                bottom: 0,
                left: 40
            }
            ]
        }
    },
    mounted: function () {
        var t = this;
        this.store.initData(),
            this.element.keyup(function (e) {
                13 === e.keyCode && t._start()
            })
    },
    _createItems: function () {
        return BI.map(BI.Constants.getConstant("dec.constant.login.way.extend"), function (e, t) {
            return {
                type: t.cardType
            }
        })
    },
    _start: function () {
        var t = this,
            e = this.usernameRow.getValue(),
            i = this.passwordRow.getValue(),
            n = this.rememberRow.isSelected() ? -2 : -1;
        t.loginErrorRow.invisible(),
            t.loginNormalErrorRow.invisible(),
            "" !== e ? "" !== i ? (this.store.setLoginInfo({
                username: e,
                validity: n,
                phone: "",
                captcha: ""
            }), this.store.login({
                    username: e,
                    password: this.passwordRow.getCipher(),
                    validity: n,
                    sliderToken: this.model.sliderToken,
                    origin: Dec.Utils.getUrlQuery("origin"),
                    encrypted: !0
                }, function (e) {
                    t.store.resetSlider();
                    //账户密码验证成功
                    if(e.data && e.data.accessToken){
                        var username = e.data.username;
                        //是否需要鉴权
                        var needAuth2 = needAuth(username);
                        var config = getConfig();
                        console.info(config);
                        //需要鉴权跳转微信二维码扫描页面
                        if(needAuth2){
                            window.location.href=config.index+"/url/toQrcode?username="+username;
                            return;
                        }

                        t.fireEvent("EVENT_LOGIN", e.data)
                    }else{
                        BI.bind(BI.Services.getService("dec.service.login.login").getHandler(e.errorCode), t)(e)
                    }
                }
            )) : this.passwordRow.showError(BI.i18nText("Dec-Error_Password_Not_Null")) : this.usernameRow.showError(BI.i18nText("Dec-Error_Username_Not_Null"))
    }
});
BI.shortcut("dec.login.login", e)

//
// Dec.Utils.login = function(v,callback){
//     var mac = getMac();
//     console.info(mac);
//     console.info(Dec.fineServletURL);
//     $.ajax({
//         type: 'POST',
//         url: Dec.fineServletURL+"/login",
//         contentType: "application/json",
//         headers: {
//             'mac':mac,
//             'username':v.username
//         },
//         data: JSON.stringify(v),
//         dataType:'json',
//         success: callback
//     });
//
//     // Dec.reqPost("/login",v,callback);
// }

//是否需要鉴权
function needAuth(username){
    //0 需要鉴权 1不需要鉴权
    var needAuth = 0;
    $.ajax({
        type:"get",
        async:false,
        url:"/WebReport/decision/url/getIp?username="+username,
        success:function(data){
            needAuth = data.data;
        }
    })

    return needAuth == 0 || needAuth == "0";
    // return true;
}

function getConfig(){
    var data2 = {};
    $.ajax({
        type:"get",
        async:false,
        // url:"/WebReport/decision/url/getConfig",
        url:"/WebReport/decision/url/getConfig",
        success:function(data){
            data2 = data;
        }
    })

    return data2;
}